// Automatically generated by modcc

#include <arbor/mechanism_abi.h>

#include "CaDynamics.hpp"
#include "Ca_HVA.hpp"
#include "Ca_LVA.hpp"
#include "Ih.hpp"
#include "Im.hpp"
#include "Im_v2.hpp"
#include "K_P.hpp"
#include "K_T.hpp"
#include "Kd.hpp"
#include "Kv2like.hpp"
#include "Kv3_1.hpp"
#include "NaTa.hpp"
#include "NaTs.hpp"
#include "NaV.hpp"
#include "Nap.hpp"
#include "SK.hpp"

#ifdef STANDALONE
extern "C" {
    [[gnu::visibility("default")]] const void* get_catalogue(int* n) {
        *n = 16;
        static arb_mechanism cat[16] = {
            make_arb_allen_catalogue_CaDynamics(),
            make_arb_allen_catalogue_Ca_HVA(),
            make_arb_allen_catalogue_Ca_LVA(),
            make_arb_allen_catalogue_Ih(),
            make_arb_allen_catalogue_Im(),
            make_arb_allen_catalogue_Im_v2(),
            make_arb_allen_catalogue_K_P(),
            make_arb_allen_catalogue_K_T(),
            make_arb_allen_catalogue_Kd(),
            make_arb_allen_catalogue_Kv2like(),
            make_arb_allen_catalogue_Kv3_1(),
            make_arb_allen_catalogue_NaTa(),
            make_arb_allen_catalogue_NaTs(),
            make_arb_allen_catalogue_NaV(),
            make_arb_allen_catalogue_Nap(),
            make_arb_allen_catalogue_SK(),
        };
        return (void*)cat;
    }
}

#else

#include <arbor/mechanism.hpp>
#include <arbor/assert.hpp>

#include "allen_catalogue.hpp"

namespace arb {
mechanism_catalogue build_allen_catalogue() {
    mechanism_catalogue cat;
    {
        auto mech = make_arb_allen_catalogue_CaDynamics();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Ca_HVA();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Ca_LVA();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Ih();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Im();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Im_v2();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_K_P();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_K_T();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Kd();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Kv2like();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Kv3_1();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_NaTa();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_NaTs();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_NaV();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_Nap();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_allen_catalogue_SK();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    return cat;
}

ARB_ARBOR_API const mechanism_catalogue& global_allen_catalogue() {
    static mechanism_catalogue cat = build_allen_catalogue();
    return cat;
}
} // namespace arb
#endif
