// Automatically generated by modcc

#include <arbor/mechanism_abi.h>

#include "CaDynamics_E2.hpp"
#include "Ca_HVA.hpp"
#include "Ca_LVAst.hpp"
#include "Ih.hpp"
#include "Im.hpp"
#include "K_Pst.hpp"
#include "K_Tst.hpp"
#include "Nap_Et2.hpp"
#include "NaTa_t.hpp"
#include "NaTs2_t.hpp"
#include "SK_E2.hpp"
#include "SKv3_1.hpp"

#ifdef STANDALONE
extern "C" {
    [[gnu::visibility("default")]] const void* get_catalogue(int* n) {
        *n = 12;
        static arb_mechanism cat[12] = {
            make_arb_bbp_catalogue_CaDynamics_E2(),
            make_arb_bbp_catalogue_Ca_HVA(),
            make_arb_bbp_catalogue_Ca_LVAst(),
            make_arb_bbp_catalogue_Ih(),
            make_arb_bbp_catalogue_Im(),
            make_arb_bbp_catalogue_K_Pst(),
            make_arb_bbp_catalogue_K_Tst(),
            make_arb_bbp_catalogue_Nap_Et2(),
            make_arb_bbp_catalogue_NaTa_t(),
            make_arb_bbp_catalogue_NaTs2_t(),
            make_arb_bbp_catalogue_SK_E2(),
            make_arb_bbp_catalogue_SKv3_1(),
        };
        return (void*)cat;
    }
}

#else

#include <arbor/mechanism.hpp>
#include <arbor/assert.hpp>

#include "bbp_catalogue.hpp"

namespace arb {
mechanism_catalogue build_bbp_catalogue() {
    mechanism_catalogue cat;
    {
        auto mech = make_arb_bbp_catalogue_CaDynamics_E2();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_Ca_HVA();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_Ca_LVAst();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_Ih();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_Im();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_K_Pst();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_K_Tst();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_Nap_Et2();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_NaTa_t();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_NaTs2_t();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_SK_E2();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_bbp_catalogue_SKv3_1();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    return cat;
}

ARB_ARBOR_API const mechanism_catalogue& global_bbp_catalogue() {
    static mechanism_catalogue cat = build_bbp_catalogue();
    return cat;
}
} // namespace arb
#endif
