// Automatically generated by modcc

#include <arbor/mechanism_abi.h>

#include "exp2syn.hpp"
#include "expsyn.hpp"
#include "expsyn_curr.hpp"
#include "expsyn_stdp.hpp"
#include "hh.hpp"
#include "kamt.hpp"
#include "kdrmt.hpp"
#include "nax.hpp"
#include "nernst.hpp"
#include "pas.hpp"
#include "gj.hpp"
#include "decay.hpp"
#include "inject.hpp"
#include "v_clamp.hpp"
#include "v_limit.hpp"

#ifdef STANDALONE
extern "C" {
    [[gnu::visibility("default")]] const void* get_catalogue(int* n) {
        *n = 15;
        static arb_mechanism cat[15] = {
            make_arb_default_catalogue_exp2syn(),
            make_arb_default_catalogue_expsyn(),
            make_arb_default_catalogue_expsyn_curr(),
            make_arb_default_catalogue_expsyn_stdp(),
            make_arb_default_catalogue_hh(),
            make_arb_default_catalogue_kamt(),
            make_arb_default_catalogue_kdrmt(),
            make_arb_default_catalogue_nax(),
            make_arb_default_catalogue_nernst(),
            make_arb_default_catalogue_pas(),
            make_arb_default_catalogue_gj(),
            make_arb_default_catalogue_decay(),
            make_arb_default_catalogue_inject(),
            make_arb_default_catalogue_v_clamp(),
            make_arb_default_catalogue_v_limit(),
        };
        return (void*)cat;
    }
}

#else

#include <arbor/mechanism.hpp>
#include <arbor/assert.hpp>

#include "default_catalogue.hpp"

namespace arb {
mechanism_catalogue build_default_catalogue() {
    mechanism_catalogue cat;
    {
        auto mech = make_arb_default_catalogue_exp2syn();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_expsyn();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_expsyn_curr();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_expsyn_stdp();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_hh();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_kamt();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_kdrmt();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_nax();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_nernst();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_pas();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_gj();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_decay();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_inject();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_v_clamp();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_default_catalogue_v_limit();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    return cat;
}

ARB_ARBOR_API const mechanism_catalogue& global_default_catalogue() {
    static mechanism_catalogue cat = build_default_catalogue();
    return cat;
}
} // namespace arb
#endif
