// Automatically generated by modcc

#include <arbor/mechanism_abi.h>

#include "ou_input.hpp"
#include "calcium_based_synapse.hpp"

#ifdef STANDALONE
extern "C" {
    [[gnu::visibility("default")]] const void* get_catalogue(int* n) {
        *n = 2;
        static arb_mechanism cat[2] = {
            make_arb_stochastic_catalogue_ou_input(),
            make_arb_stochastic_catalogue_calcium_based_synapse(),
        };
        return (void*)cat;
    }
}

#else

#include <arbor/mechanism.hpp>
#include <arbor/assert.hpp>

#include "stochastic_catalogue.hpp"

namespace arb {
mechanism_catalogue build_stochastic_catalogue() {
    mechanism_catalogue cat;
    {
        auto mech = make_arb_stochastic_catalogue_ou_input();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    {
        auto mech = make_arb_stochastic_catalogue_calcium_based_synapse();
        auto ty = mech.type();
        auto nm = ty.name;
        auto ig = mech.i_gpu();
        auto ic = mech.i_cpu();
        arb_assert(ic || ig);
        cat.add(nm, ty);
        if (ic) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ic));
        if (ig) cat.register_implementation(nm, std::make_unique<arb::mechanism>(ty, *ig));
    }
    return cat;
}

ARB_ARBOR_API const mechanism_catalogue& global_stochastic_catalogue() {
    static mechanism_catalogue cat = build_stochastic_catalogue();
    return cat;
}
} // namespace arb
#endif
